* Generic session options - page and line size, no page breaks;
OPTIONS nonumber nodate nocenter pagesize=MAX linesize=120 formdlim=' ';											
* Kill default titles on output; 
TITLE; 

* Location where data is stored -- CHANGE THIS;
%LET filesave= F:\Example Data\Chapter 5 Data;
LIBNAME filesave "&filesave.";

* Import data into work library, center time;
DATA example5; SET filesave.example5;
	time = wave - 1; LABEL time= "time: Time in Study (0=1)";
RUN;

TITLE1 "Saturated Means, Unstructured Variance Model -- TOTAL ANSWER KEY";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome = wave / SOLUTION DDFM=Satterthwaite;
	REPEATED wave / R RCORR TYPE=UN SUBJECT=IDnum;
	LSMEANS wave;
RUN;

TITLE1 "Saturated Means, Random Intercept Variance Model -- MEANS ANSWER KEY";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome = wave / SOLUTION DDFM=Satterthwaite;
	RANDOM INTERCEPT / G V VCORR TYPE=UN SUBJECT=IDnum;
	REPEATED wave / R TYPE=VC SUBJECT=IDnum;
	LSMEANS wave;
RUN;

TITLE1 "Eq 5.1: Empty Means, Random Intercept Model";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome =  / SOLUTION DDFM=Satterthwaite;
	RANDOM INTERCEPT  / G V VCORR TYPE=UN SUBJECT=IDnum;
	REPEATED wave / R TYPE=VC SUBJECT=IDnum;
RUN;

TITLE1 "Eq 5.3: Fixed Linear Time, Random Intercept Model";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome = time / SOLUTION DDFM=Satterthwaite;
	RANDOM INTERCEPT  / G V VCORR TYPE=UN SUBJECT=IDnum;
	REPEATED wave / R TYPE=VC SUBJECT=IDnum;
	ESTIMATE "Intercept at Time 0"	int 1 time 0;
	ESTIMATE "Intercept at Time 1"	int 1 time 1;
	ESTIMATE "Intercept at Time 2"	int 1 time 2;
	ESTIMATE "Intercept at Time 3"	int 1 time 3;
RUN;

TITLE1 "Eq 5.5: Random Linear Time Model";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome = time / SOLUTION DDFM=Satterthwaite;
	RANDOM INTERCEPT time / G GCORR V VCORR TYPE=UN SUBJECT=IDnum;
	REPEATED wave / R TYPE=VC SUBJECT=IDnum;
	ESTIMATE "Intercept at Time 0"	int 1 time 0;
	ESTIMATE "Intercept at Time 1"	int 1 time 1;
	ESTIMATE "Intercept at Time 2"	int 1 time 2;
	ESTIMATE "Intercept at Time 3"	int 1 time 3;
RUN;

TITLE1 "Random Linear Time Model + AR1 R Matrix";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome = time / SOLUTION DDFM=Satterthwaite;
	RANDOM INTERCEPT time / G GCORR V VCORR TYPE=UN SUBJECT=IDnum;
	REPEATED / R RCORR TYPE=AR(1) SUBJECT=IDnum;
RUN;

TITLE1 "Random Linear Time Model + TOEP2 R Matrix";
PROC MIXED DATA=example5 COVTEST NOITPRINT NOCLPRINT METHOD=REML;
	CLASS IDnum wave;
	MODEL outcome = time / SOLUTION DDFM=Satterthwaite;
	RANDOM INTERCEPT time / G GCORR V VCORR TYPE=UN SUBJECT=IDnum;
	REPEATED wave / R RCORR TYPE=TOEP(2) SUBJECT=IDnum;
RUN;




